function [E,Lambda]=LOOC(Y,alpha)
%%% use diag(S) as the shrinkage estimate  %%%%
%%% choose alpha to maximize LOOL %%%%%

[N,M]=size(Y);
S=Y*Y'/M;

if nargin == 2
     alpha_opt=alpha;
else
     %%%%  the simplifed version for LOOL with the biased estimator %%
     alpha=0.001:0.001:0.1;
     for i=1:size(alpha,2)
           alpha1=alpha(i);
           alpha2=1-alpha1;
           G=alpha1*diag(diag(S))+alpha2*(M)/(M-1)*S;
           k=alpha2/(M-1);
           [E,Lambda]=eig(G);
           Ginv=E*diag((1./diag(Lambda)))*E';
           logGdet=sum(log(diag(Lambda)));
           log_likelihood=zeros(M,1);
           for m=1:M
                d=Y(:,m)'*Ginv*Y(:,m);
                log_likelihood(m)=-M/2*log(2*pi)-1/2*logGdet-1/2*log(1-k*d)-1/2*(d/(1-k*d));
           end
           avg_LooL(i)=sum(log_likelihood)/M;
      end
      avg_LooL;

      [val_max,i_max]=max(avg_LooL);
      alpha_opt=alpha(i_max)
end

R=alpha_opt*diag(diag(S))+(1-alpha_opt)*S;
[E,Lambda]=eig(R);
[Lambda,I] = sort(diag(Lambda),'descend');
E=E(:,I);
Lambda=diag(Lambda);

